/* This program is supposed to run on IBM-PC compatibles */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define ELEMENTS	100
#define MAX_VALUE	999
#define COLS		10

float *vector(unsigned int);
void free_vector(float*);
void print_vector(float*, unsigned int);
void mystery1(float*, unsigned int);
void mystery2(float*, unsigned int);

float *vector(unsigned int size)
{
float *a;

 a = (float*)malloc(size * sizeof(float));
 if (a == NULL) {
   fprintf(stderr, "Failed memory allocation in vector()");
   exit(1);
 }
 return a;
}

void free_vector(float *vector)
{
 free((char*)vector);
}

void print_vector(float *vector, unsigned int size)
{
int i;

 for (i=0; i<size; i++) {
   if ((i % COLS == 0) && i > 0) printf("\n");
   printf("%7.2f", vector[i]);
 }
}


int main(void)
{
int i;
float *ar;

/* allocate space for the array to sort */

ar = vector(ELEMENTS);

/* generate random values to be sorted; first initialize the random  */
/* number generator such that, each time rand() is called it will    */
/* generate different numbers.					     */

randomize();
for (i=0; i<ELEMENTS; i++)
  ar[i] = (float)(rand() % MAX_VALUE);

/* print the initial values in the array */

printf("\nInitial array:\n");
print_vector(ar, ELEMENTS);

/* sort the array */

mystery1(ar, ELEMENTS);

/* print the sorted array */

printf("\nSorted array:\n");
print_vector(ar, ELEMENTS);

/* free the space aoccupied by the array */

free_vector(ar);
}


void mystery1(float* ll1l1l1ll1, unsigned int l1l1ll1ll1)
{
int l1ll1ll1l1, l1ll1lll11, lll1l1ll1l;
float l1lll1ll11;

 for (l1ll1ll1l1=0; l1ll1ll1l1<l1l1ll1ll1-1; l1ll1ll1l1++) {
   lll1l1ll1l = l1ll1ll1l1;
   for (l1ll1lll11=l1ll1ll1l1+1; l1ll1lll11<l1l1ll1ll1; l1ll1lll11++) {
     if (ll1l1l1ll1[l1ll1lll11] < ll1l1l1ll1[lll1l1ll1l]) lll1l1ll1l = l1ll1lll11;
   }
   l1lll1ll11 = ll1l1l1ll1[l1ll1ll1l1];
   ll1l1l1ll1[l1ll1ll1l1] = ll1l1l1ll1[lll1l1ll1l];
   ll1l1l1ll1[lll1l1ll1l] = l1lll1ll11;
 }
}

void mystery2(float* vector, unsigned int size)
{
int i, j, v;

 for (i=1; i<size; i++) {
   v = vector[i];
   j = i;
   while(vector[j-1] > v) {
     vector[j] = vector[j-1];
     j--;
   }
   vector[j] = v;
 }
}
